<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Document StructType
 * @subpackage Structs
 */
class Document extends AbstractStructBase
{
    /**
     * The id_country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $id_country;
    /**
     * The id_expiry
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $id_expiry;
    /**
     * The id_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $id_number;
    /**
     * The id_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $id_type;
    /**
     * Constructor method for Document
     * @uses Document::setId_country()
     * @uses Document::setId_expiry()
     * @uses Document::setId_number()
     * @uses Document::setId_type()
     * @param string $id_country
     * @param string $id_expiry
     * @param string $id_number
     * @param string $id_type
     */
    public function __construct($id_country = null, $id_expiry = null, $id_number = null, $id_type = null)
    {
        $this
            ->setId_country($id_country)
            ->setId_expiry($id_expiry)
            ->setId_number($id_number)
            ->setId_type($id_type);
    }
    /**
     * Get id_country value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId_country()
    {
        return isset($this->id_country) ? $this->id_country : null;
    }
    /**
     * Set id_country value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id_country
     * @return \StructType\Document
     */
    public function setId_country($id_country = null)
    {
        // validation for constraint: string
        if (!is_null($id_country) && !is_string($id_country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id_country, true), gettype($id_country)), __LINE__);
        }
        if (is_null($id_country) || (is_array($id_country) && empty($id_country))) {
            unset($this->id_country);
        } else {
            $this->id_country = $id_country;
        }
        return $this;
    }
    /**
     * Get id_expiry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId_expiry()
    {
        return isset($this->id_expiry) ? $this->id_expiry : null;
    }
    /**
     * Set id_expiry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id_expiry
     * @return \StructType\Document
     */
    public function setId_expiry($id_expiry = null)
    {
        // validation for constraint: string
        if (!is_null($id_expiry) && !is_string($id_expiry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id_expiry, true), gettype($id_expiry)), __LINE__);
        }
        if (is_null($id_expiry) || (is_array($id_expiry) && empty($id_expiry))) {
            unset($this->id_expiry);
        } else {
            $this->id_expiry = $id_expiry;
        }
        return $this;
    }
    /**
     * Get id_number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId_number()
    {
        return isset($this->id_number) ? $this->id_number : null;
    }
    /**
     * Set id_number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id_number
     * @return \StructType\Document
     */
    public function setId_number($id_number = null)
    {
        // validation for constraint: string
        if (!is_null($id_number) && !is_string($id_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id_number, true), gettype($id_number)), __LINE__);
        }
        if (is_null($id_number) || (is_array($id_number) && empty($id_number))) {
            unset($this->id_number);
        } else {
            $this->id_number = $id_number;
        }
        return $this;
    }
    /**
     * Get id_type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId_type()
    {
        return isset($this->id_type) ? $this->id_type : null;
    }
    /**
     * Set id_type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id_type
     * @return \StructType\Document
     */
    public function setId_type($id_type = null)
    {
        // validation for constraint: string
        if (!is_null($id_type) && !is_string($id_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id_type, true), gettype($id_type)), __LINE__);
        }
        if (is_null($id_type) || (is_array($id_type) && empty($id_type))) {
            unset($this->id_type);
        } else {
            $this->id_type = $id_type;
        }
        return $this;
    }
}
