<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for get_rate StructType
 * @subpackage Structs
 */
class Get_rate extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credential
     */
    public $login;
    /**
     * The to_country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $to_country;
    /**
     * The from_currency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $from_currency;
    /**
     * The to_currency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $to_currency;
    /**
     * Constructor method for get_rate
     * @uses Get_rate::setLogin()
     * @uses Get_rate::setTo_country()
     * @uses Get_rate::setFrom_currency()
     * @uses Get_rate::setTo_currency()
     * @param \StructType\Credential $login
     * @param string $to_country
     * @param string $from_currency
     * @param string $to_currency
     */
    public function __construct(\StructType\Credential $login = null, $to_country = null, $from_currency = null, $to_currency = null)
    {
        $this
            ->setLogin($login)
            ->setTo_country($to_country)
            ->setFrom_currency($from_currency)
            ->setTo_currency($to_currency);
    }
    /**
     * Get login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credential|null
     */
    public function getLogin()
    {
        return isset($this->login) ? $this->login : null;
    }
    /**
     * Set login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credential $login
     * @return \StructType\Get_rate
     */
    public function setLogin(\StructType\Credential $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->login);
        } else {
            $this->login = $login;
        }
        return $this;
    }
    /**
     * Get to_country value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTo_country()
    {
        return isset($this->to_country) ? $this->to_country : null;
    }
    /**
     * Set to_country value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $to_country
     * @return \StructType\Get_rate
     */
    public function setTo_country($to_country = null)
    {
        // validation for constraint: string
        if (!is_null($to_country) && !is_string($to_country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($to_country, true), gettype($to_country)), __LINE__);
        }
        if (is_null($to_country) || (is_array($to_country) && empty($to_country))) {
            unset($this->to_country);
        } else {
            $this->to_country = $to_country;
        }
        return $this;
    }
    /**
     * Get from_currency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFrom_currency()
    {
        return isset($this->from_currency) ? $this->from_currency : null;
    }
    /**
     * Set from_currency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $from_currency
     * @return \StructType\Get_rate
     */
    public function setFrom_currency($from_currency = null)
    {
        // validation for constraint: string
        if (!is_null($from_currency) && !is_string($from_currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($from_currency, true), gettype($from_currency)), __LINE__);
        }
        if (is_null($from_currency) || (is_array($from_currency) && empty($from_currency))) {
            unset($this->from_currency);
        } else {
            $this->from_currency = $from_currency;
        }
        return $this;
    }
    /**
     * Get to_currency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTo_currency()
    {
        return isset($this->to_currency) ? $this->to_currency : null;
    }
    /**
     * Set to_currency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $to_currency
     * @return \StructType\Get_rate
     */
    public function setTo_currency($to_currency = null)
    {
        // validation for constraint: string
        if (!is_null($to_currency) && !is_string($to_currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($to_currency, true), gettype($to_currency)), __LINE__);
        }
        if (is_null($to_currency) || (is_array($to_currency) && empty($to_currency))) {
            unset($this->to_currency);
        } else {
            $this->to_currency = $to_currency;
        }
        return $this;
    }
}
